#!/usr/bin/perl

# Makes a character graphic string
# 
# Needs "font.pl", built from a font BDF file using the mkfont utility
# 
# Takes four args:
# 
# boxwidth of graphic box, use '%' for minimum width based on string width
# boxheight of graphic box, use '%' for minimum height based on font height
# string to write in graphic box using font
# filename to write xbm output file into
# OPTIONAL fifth arg, fontascent, override default
# OPTIONAL sixth arg, fontdescent, override default
# OPTIONAL seventh arg, if >0 enable transparency
# OPTIONAL eigth arg, if >0 disable informational messages
# OPTIONAL ninth arg, if >0 then debug mode (print bits)

use Image::Magick;
require "font.pl";

sub mkim() {
my ($w, $h, $c, $pw, $i, $x, $y, $bw, $a, $b, $l, $cl, $cb, $o, $m, $po, $xw, $bl, $ch, $ocl, $image);
my @blob = ();
my $quiet=0;
my $debug=0;
my $transparent=0;
$CM_FONT_ASCENT= $_[4] if (defined $_[4]);
$CM_FONT_DESCENT= $_[5] if (defined $_[5]);
my $transparent= $_[6] if (defined $_[6]);
my $quiet = $_[7] if (defined $_[7]);
my $debug = $_[8] if (defined $_[8]);
my $s = $_[2];
#$s = "";
#for ($i=32; $i <= 126; $i++) {
#  $s .= chr $i;
#}
for ($pw=0,$c=0; $c<length($s); $c++) {
  for ($i=0; $i<@CM_FONT_CHARS && $CM_FONT_CHARS[$i][$CM_ENC] != ord substr($s,$c); $i++) {}
  if ($i == @CM_FONT_CHARS) {
    printf "Error: character '%c' not found\n",substr($s,$c,1);
    return(1);
  }
  $pw += $CM_FONT_CHARS[$i][$CM_DPW];
}
$w = ($_[0] eq "%") ? $pw : $_[0];
$h = ($_[1] eq "%") ? $CM_FONT_ASCENT : $_[1];
if ($pw>$w) {
  printf "Error: string width bigger than bounding box, %d > %d\n", $pw, $w;
  return(1);
}
if ($CM_FONT_ASCENT>$h) {
  printf "Error: font height bigger than bounding box, %d > %d\n", $CM_FONT_ASCENT, $h;
  return(1);
}
$x = ($w - $pw) / 2;
$y = ($h - $CM_FONT_ASCENT) / 2;
printf "TXT=\"%s\" BOX=%dx%d STR=%dx%d ASC=%d DES=%d LFT=%d TOP=%d OUT=%s\n",
  $s, $w, $h, $pw, $CM_FONT_ASCENT, $CM_FONT_ASCENT, $CM_FONT_DESCENT, $x, $y, $_[3] if (!$quiet);
$blob[0]="#define _width ".$w."\n";
$blob[0].="#define _height ".$h."\n";
$blob[0].="static char _bits[] = {\n";
$xw = $w % 8;
$xw = 8 - $xw if ($xw != 0);
for ($l = 0; $l < $y; $l++) {
  for ($b = 0; $b < $w; $b++) {
    $ch .= "0";
    printf "-" if ($debug);
  }
  for ($b = 0; $b < $xw; $b++) {
    $ch .= "1";
    printf "X" if ($debug);
  }
  printf "\n" if ($debug);
}
for ($cl = 0; $l < $CM_FONT_ASCENT + $y; $l++, $cl++) {
  for ($b = 0; $b < $x; $b++) {
    $ch .= "0";
    printf "-" if ($debug);
  }
  for ($c = 0; $c < length($s); $c++) {
    for ($i=0; $i<@CM_FONT_CHARS && $CM_FONT_CHARS[$i][$CM_ENC] != ord substr($s,$c); $i++) {}
    $m = ($CM_FONT_CHARS[$i][$CM_APW]>8) ? 15 : 7;
    $cb = 2 ** $m;
    for ($po=$CM_FONT_CHARS[$i][$CM_APO]; $po>0; $po--) {
      $m++;
      $ch .= "0";
      printf "." if ($debug);
      $b++;
    }
    if ($cl>=($CM_FONT_ASCENT-$CM_FONT_DESCENT-$CM_FONT_CHARS[$i][$CM_DPH]-$CM_FONT_CHARS[$i][$CM_BLS])) {
      $ocl = $cl-($CM_FONT_ASCENT-$CM_FONT_DESCENT-$CM_FONT_CHARS[$i][$CM_DPH]-$CM_FONT_CHARS[$i][$CM_BLS]);
      for (; $cb > 2 ** ($m-$CM_FONT_CHARS[$i][$CM_DPW]); $cb/=2) {
        $o = ($ocl > $CM_FONT_CHARS[$i][$CM_DPH]) ? 0x0 : $CM_FONT_CHARS[$i][$ocl+$CM_BIT];
        $ch .= ($o & $cb) > 0 ? "1" : "0";
        printf "%s", ($o & $cb) > 0 ? "@" : "-" if ($debug);
        $b++;
      }
    } else {
      for (; $cb > 2 ** ($m-$CM_FONT_CHARS[$i][$CM_DPW]); $cb/=2) {
        $ch .= "0";
        printf "-" if ($debug);
        $b++;
      }
    }
  }
  for (; $b < $w; $b++) {
    $ch .= "0";
    printf "-" if ($debug);
  }
  for ($b = 0; $b < $xw; $b++) {
    $ch .= "1";
    printf "X" if ($debug);
  }
  printf "\n" if ($debug);
}
for (; $l < $h; $l++) {
  for ($b = 0; $b < $w; $b++) {
    $ch .= "0";
    printf "-" if ($debug);
  }
  for ($b = 0; $b < $xw; $b++) {
    $ch .= "1";
    printf "X" if ($debug);
  }
  printf "\n" if ($debug);
}
for ($c=0,$b=1,$a=0,$i=0; $c<length($ch); $c++, $b=(($b==0)?1:$b*2)) {
  if (($c + 1) % 8 == 0) {
    $a |= $b * substr($ch,$c,1);
    $blob[0] .= sprintf("0x%.2x, ",$a);
    $b = 0;
    $a = 0;
    $blob[0] .= "\n" if ((++$i) % 8 == 0);
  } else {
    $a |= $b * substr($ch,$c,1);
  }
}
$blob[0] .= "};\n";

$image=Image::Magick->new(magick=>'xbm');
$image->BlobToImage(@blob);
$image->Transparent(color=>'white') if ($transparent);
my $err = $image->Write($_[3]);
warn "$err" if "$err";
undef $image;

return(0);
}
