#if DO_PROFILER|DO_FOLLOWER
// Profiler Objects and Methods

#if DO_FOLLOWER
var ProfileStack = 0;
#endif

function ProfileEnter() {
#if DO_PROFILER
  this.calls++;
  var d = new Date();
  this.time[this.stack++] = d.getTime();
#endif
#if DO_FOLLOWER
  var s="";
  for(var i=0; i<ProfileStack; i++) s+=" ";
  ConsoleWrite(s+">"+this.name);
  ProfileStack++;
#endif
}

function ProfileLeave() {
#if DO_PROFILER 
  var d = new Date();
  var nt = d.getTime() - this.time[--this.stack];
  if (nt<this.min||!this.min) this.min = nt;
  if (nt>this.max||!this.max) this.max = nt;
  this.sum += nt;
  this.avg = this.sum / this.calls;
#endif
#if DO_FOLLOWER
  ProfileStack--;
  var s="";
  for(var i=0; i<ProfileStack; i++) s+=" ";
  ConsoleWrite(s+"<"+this.name
#if DO_PROFILER
  +"@("+nt+")"
#endif
  );
#endif
}

function Profile(n) {
  this.name = n;
#if DO_PROFILER
  this.calls = 0;
  this.min = 0;
  this.avg = 0;
  this.max = 0;
  this.sum = 0;
  this.time = [];
  this.stack = 0;
#endif
  this.enter = ProfileEnter;
  this.leave = ProfileLeave;
}

function ProfilerStats() {
  ConsoleWrite("PROFILE");
  var sumt=0;
  for (var p in profiler) {
    if (p!="stats"&&p!="reset") sumt += profiler[p].sum;
  }
  var per, sumtp=0;
  for (var p in profiler) {
    if (p!="stats"&&p!="reset") {
      per=profiler[p].sum/sumt*100;
      sumtp+=per;
      ConsoleWrite(profiler[p].name+"  "+profiler[p].calls+"@("+profiler[p].min+"/"+profiler[p].avg+"/"+profiler[p].max+")="+profiler[p].sum+"["+per+"]");
    }
  }
  ConsoleWrite("TOTAL  "+sumt+"["+sumtp+"]");
}

function ProfilerReset() {
  for (var p in profiler) {
    profiler[p].sum = 0;
    profiler[p].calls = 0;
    profiler[p].min = 0;
    profiler[p].avg = 0;
    profiler[p].max = 0;
    profiler[p].sum = 0;
  }
}

function Profiler() {
  this.stats = ProfilerStats;
  this.reset = ProfilerReset;
}

profiler = new Profiler();

#define _PROFILER_SETUP(f) profiler.f=new Profile("f");
#define _PROFILER_ENTER(f) profiler.f.enter();
#if DO_FOLLOWER
#define _PROFILER_ARGS(f) _s="";for(var _i=0;_i<ProfileStack;_i++)_s+=" ";var _i=f.arity;for(var _a in f){if(_i==0)break;else _i--;print(_s+_a+"="+f[_a]);}
#else
#define _PROFILER_ARGS(f)
#endif
#define _PROFILER_LEAVE(f) profiler.f.leave();

#else

#define _PROFILER_SETUP(f)
#define _PROFILER_ENTER(f)
#define _PROFILER_ARGS(f)
#define _PROFILER_LEAVE(f)

#endif
